#define WIN31
#include <windows.h>
/* For the fancy looking Borland dialog box routines */
#ifdef USES_BWCC
#include <bwcc.h>
#endif
#include "flatm.h"
#pragma hdrstop
#include <time.h>
#include "\borlandc\winmem\memman.h"
#include "flatdata.h"
#include "flatsort.h"
#ifdef USES_MEMCHECK
/* Memory checking routines  by StratosWare Corp. */
#include "\wmemchec\memcheck.h"
#endif

#define SORTLISTNULL ((struct tagEVENTSORT *)NULL)

struct tagEVENTSORT *ptrfirstsort;
struct tagEVENTSORT *ptrnewsort;
struct tagEVENTSORT *ptrthissort;
struct tagEVENTSORT *ptrP1;
struct tagEVENTSORT *ptrP2;
struct tagEVENTSORT *ptrNextRec;


/*--------------------------------------------
-
-         FLATSORT.C for Flat Windows Program
-
-      Builds a linked sort array.  Data records
-       can be sorted by date or record number
-
-               Dennis R. Fischer
-                 Denam Systems
-          1115 Madison St. NE  Suite 226
-              Salem, Oregon  97303
-
-             CompuServe 70405,1422
-        Internet 70405.1422@compuserve.com
-
-        Developed with Borland 3.1 Compiler
-
-     Free for the taking but please give credit
-                where credit is do
-
----------------------------------------------*/              

LONG GetNextSortRec (void)
{
	/* Grabs the next waiting sort and
		 return the file record number
  */
	LONG lRecnum = -1L;

  if (ptrNextRec) {
		lRecnum = ptrNextRec->recnum;
		ptrNextRec = ptrNextRec->psNext;
  }
  return lRecnum;
}  /* GetNextSortRec */

void ClearSortPtr (void)
{
	/* Clear the sort pointer */
	ptrfirstsort=SORTLISTNULL;
	ptrnewsort=SORTLISTNULL;
	ptrthissort=SORTLISTNULL;
  ptrNextRec=SORTLISTNULL;
}  /* ClearSortPtr */

BOOL AddDateSort (LONG lRecnum, time_t lDateval)
{
	/* Creates a sort pointer and puts it in the
		 proper location when sorted by date
  */
	BOOL bGood, quit;

	bGood = FALSE;
  /* create it */
	ptrnewsort = (struct tagEVENTSORT *) AllocMemMan(sizeof (struct tagEVENTSORT));
  if (ptrnewsort) {
		bGood = TRUE;
		ptrnewsort->recnum = lRecnum;
		ptrnewsort->lSortval = lDateval;
		ptrnewsort->psNext = SORTLISTNULL;
    ptrnewsort->psLast = SORTLISTNULL;
		if (ptrfirstsort == SORTLISTNULL) {
    	/* no prior entry so add first record */
			ptrNextRec = ptrfirstsort = ptrthissort = ptrnewsort;
		}
		else {
			/* we're sorting by date */
			quit = FALSE;
			ptrP1 = ptrfirstsort;
			ptrP2 = ptrP1->psNext;
			do{
				if (ptrnewsort->lSortval < ptrfirstsort->lSortval) {
					/* New data is < first record */
					ptrthissort = ptrnewsort;                            /* temp rec */
					ptrthissort->psNext = ptrfirstsort;                    /* point to old 1st */
					ptrthissort->psLast = SORTLISTNULL;   /* no beginning */
					ptrfirstsort->psLast = ptrthissort;
					ptrP1 = ptrfirstsort;
					ptrfirstsort = ptrthissort;
					ptrNextRec = ptrfirstsort;
					quit = TRUE;
				}
				if ((!ptrP2) && (!quit)){
					/* last record was found */
					quit = TRUE;
					ptrP1->psNext = ptrnewsort;
					ptrthissort = ptrnewsort;
					ptrthissort->psLast = ptrP1;
				}
				if (!quit) {
					if (!quit) {
						/* find position between two */
						if (ptrnewsort->lSortval >= ptrP1->lSortval) {
							/* pnew is >= p1 */
							if (ptrnewsort->lSortval <= ptrP2->lSortval) {
								/* pnew <= p2 so the new record falls in the middle */
								quit = TRUE;
								/* new record */
								ptrthissort = ptrnewsort;
								ptrthissort->psLast = ptrP1;
								ptrthissort->psNext = ptrP2;
								/* old 1st record */
								ptrP1->psNext = ptrthissort;
								/* old 2nd record */
								ptrP2->psLast = ptrthissort;
							}
						}
					}

				}
				if (!quit) {
					ptrP1 = ptrP1->psNext;
					ptrP2 = ptrP1->psNext;
				}
				if (!ptrP1)
					quit = TRUE;
			}while (!quit);
		}
	}
  if (!bGood)
		BWCCMessageBox(NULL, "It Appears You Ran Out Of Memory",
			         "Flat", MB_OK | MB_ICONEXCLAMATION);
  return bGood;
}  /* AddDateSort */

BOOL AddRecordSort (LONG lRecnum)
{
	/* creates a new sort pointer and adds it.  Pointer
		 is just added to the end of the list
  */
	BOOL bGood, quit;
 
	bGood = FALSE;
	ptrnewsort = (struct tagEVENTSORT *) AllocMemMan(sizeof (struct tagEVENTSORT));
  if (ptrnewsort) {
		bGood = TRUE;
		ptrnewsort->recnum = lRecnum;
    ptrnewsort->lSortval = lRecnum;
		ptrnewsort->psNext = SORTLISTNULL;
    ptrnewsort->psLast = SORTLISTNULL;
		if (ptrfirstsort == SORTLISTNULL) {
    	/* first record so start list */
			ptrNextRec = ptrfirstsort = ptrthissort = ptrnewsort;
		}
		else {
			/* Add it to the end of the list */
			ptrthissort = ptrfirstsort;
			while (ptrthissort->psNext != SORTLISTNULL){
				ptrthissort = ptrthissort->psNext;
			}
			ptrthissort->psNext = ptrnewsort;
			ptrnewsort->psLast = ptrthissort;
			ptrthissort = ptrnewsort;
		}
	}
  if (!bGood)
		BWCCMessageBox(NULL, "It Appears You Ran Out Of Memory",
							 "Flat", MB_OK | MB_ICONEXCLAMATION);
  return bGood;
}  /* AddRecordSort */

void ClearSortMem (void)
{
	/* Deletes all the sort pointers from memory */
	struct tagEVENTSORT *ptrnextsort;

	if (ptrfirstsort) {
  	ptrthissort = ptrfirstsort;
		do{
    	ptrnextsort = ptrthissort->psNext;
      FreeMem(ptrthissort);
      ptrthissort = ptrnextsort;
    }while (ptrthissort);
	}
  ClearSortPtr();
}  /* ClearSortMem */


